﻿#include "model.h"
static int HaveAGoodDay;
namespace mm {
#line 1 "code/Emigration.mpp"
//LABEL(Emigration, EN) Emigration

/*  NOTE(Emigration, EN)

    Added at Step 7

    This module implements emigration based on emigration rates by age group, sex, and
    province of residence. The module can be switched on/off by the user.
*/

//parameters
//{
//    logical	ModelEmigration;										//EN Switch emigration on/off
//    double	EmigrationRates[SEX][AGE5_PART][PROVINCE_NAT];			//EN Emigration Rates
//};

//parameter_group PG_Emigration										//EN Emigration
//{
//    ModelEmigration, EmigrationRates
//};

//actor Person
//{
//    logical	has_emigrated = { FALSE };								//EN Person has emigrated
//    event	timeEmigrationEvent, EmigrationEvent;					//EN Emigration
//};

TIME Person::timeEmigrationEvent()
{
    if (gprParam->ModelEmigration &&  calendar_year >= MIN(SIM_YEAR_RANGE) && 
        gprParam->EmigrationRates[CHKBND(sex ,2,"EmigrationRates",0)][CHKBND(SPLIT(integer_age , AGE5_PART),13,"EmigrationRates",1)][CHKBND(province_nat ,13,"EmigrationRates",2)] > 0.0)
    {
        return WAIT(-log(RandUniform(10)) / gprParam->EmigrationRates[CHKBND(sex ,2,"EmigrationRates",0)][CHKBND(SPLIT(integer_age , AGE5_PART),13,"EmigrationRates",1)][CHKBND(province_nat ,13,"EmigrationRates",2)]);
    }
    else return TIME_INFINITE;
}

void Person::EmigrationEvent()
{
     poStateFunctions->Set_has_emigrated(  TRUE );
    Finish();
}


} // namespace 
