﻿#include "model.h"
static int HaveAGoodDay;
namespace mm {
#line 1 "code/ModelSettings.mpp"
//parameters
//{
//    long                    StartPopSampleSize;         //EN Sample size of starting population
//    double                  StartPopSize;               //EN Total population size
//
//    model_generated long    ImmiPopSampleSize;          //EN Sample size of starting population
//    model_generated double  ImmiPopSize;                //EN Total population size
//
//    model_generated long    TotalPopSampleSize;         //EN Sample size of starting population
//    model_generated double  TotalPopSize;               //EN Total population size
//
//    logical                 ScalePopulation;            //EN Scale population
//    model_generated double  ActorWeight;                //EN Actor Weight
//};

//parameter_group PG_ModelSettings                        //EN Model Settings
//{
//    StartPopSize, StartPopSampleSize, ScalePopulation
//};

void PreSimulation3()
{
    // Weight
    gprParam->ActorWeight = gprParam->StartPopSize / gprParam->StartPopSampleSize;    
    
    // Total Immigrant population
    gprParam->ImmiPopSize = 0.0;
    if (gprParam->ModelImmigration) // If immigration is switched on
    {
        for (int nSex = 0; nSex < SIZE(SEX); nSex++)
        {
            for (int nYear = 0; nYear < SIZE(SIM_YEAR_RANGE); nYear++)
            {
                gprParam->ImmiPopSize = gprParam->ImmiPopSize + gprParam->NumberImmigrants[CHKBND(nYear,101,"NumberImmigrants",0)][CHKBND(nSex,2,"NumberImmigrants",1)];
                gprParam->NumberImmigrantsTable[CHKBND(nYear,101,"NumberImmigrantsTable",0)][CHKBND(nSex,2,"NumberImmigrantsTable",1)] = gprParam->NumberImmigrants[CHKBND(nYear,101,"NumberImmigrants",0)][CHKBND(nSex,2,"NumberImmigrants",1)];;
            }
        }
    }
        
    //Total population
    gprParam->TotalPopSize = gprParam->ImmiPopSize + gprParam->StartPopSize;
    gprParam->TotalPopSampleSize = (long)(gprParam->TotalPopSize / gprParam->ActorWeight);
    
    gprParam->ImmiPopSampleSize = gprParam->TotalPopSampleSize - gprParam->StartPopSampleSize;
 };
} // namespace 
