﻿#include "model.h"
static int HaveAGoodDay;
namespace mm {
#line 1 "code/CmapReportTables.mpp"
//LABEL (CmapReportTables, EN)
//NOTE (CmapReportTables, EN)

//table_group TG_RTAB     //EN CMAP Report Tables
//{
//    RTAB_TotalPopReg,
//    RTAB_TotalPopWillaya,
//    RTAB_PopPyramidByEduc,
//    RTAB_DeathsByRegion,
//    RTAB_BirthsByRegion,
//    RTAB_BirthsByEducMother,
//    RTAB_BirthsByAgeMother,
//    RTAB_UnionFormationByAge,
//    RTAB_AgeAtFirstUnionFormation,
//    RTAB_TabDeathsByAgeGroup,
//    RTAB_EducationActivePop,
//    RTAB_PrimSchoolEntries,
//    RTAB_PrimSchoolGraduations
//};


//partition   AGE_15_16_18{ 15,17,19 };                                            //EN Age groups 


//range           RTAB_YEARS{ 2017,2050 };                                     //EN Year 
//classification  RTAB_REG
//{
//    RR_NOUAK,           //EN Nouakchott
//    RR_REST             //EN Rest of the country
//};

//partition   AGE_RTAB_MORT{ 1 };                                          //EN Age groups

//classification  RTAB_SEL_YEARS //EN Selected Years
//{
//    SY_2017,    //EN 2017
//    SY_2030,    //EN 2030
//    SY_2050     //EN 2050
//};

//classification RTAB_COL
//{
//    RC_COLUMN   //EN DATA
//};

//actor Person
//{
//    logical         in_rtab_years = WITHIN(RTAB_YEARS,calendar_year);           //EN In simulated year range
//    RTAB_YEARS      rtab_years = COERCE(RTAB_YEARS,calendar_year);              //EN Year
//    RTAB_COL        rtab_column = { RC_COLUMN };                                //EN Data Column    
//                                                                                
//    logical         in_rtab_sel_years = calendar_year == 2017 || calendar_year == 2030 || calendar_year == 2050; //EN In selected year
//    RTAB_SEL_YEARS  rtab_sel_years = (calendar_year == 2017) ? SY_2017 : ((calendar_year == 2030) ? SY_2030 : SY_2050); //EN Year
//    RTAB_REG        rtab_reg = (province_nat== PN_PROV12) ? RR_NOUAK : RR_REST;  //EN Region
//    logical         is_act_age = (integer_age > 15 && integer_age < 60);        //EN Age 16-59
//
//};

//table Person RTAB_TotalPopReg           //EN (01) Total population by main region
//[in_rtab_years]
//{
//    {
//        duration() //EN Population
//    }
//    *rtab_years
//    * rtab_reg +
//};

//table Person RTAB_TotalPopWillaya       //EN (02) Total population by Willaya
//[in_rtab_years]
//{
//    {
//        duration() //EN Population
//    }
//    *rtab_years
//    * province_nat +
//};

//table Person RTAB_PopPyramidByEduc       //EN (03) Population pyramids by main regions
//[in_rtab_sel_years]
//{
//    rtab_sel_years *
//    sex + *
//    rtab_reg + *
//    split(integer_age, AGE_FIVE) *                   //EN Age group
//{
//    duration(primary_level,PL_NO),              //EN Never entered primary school
//    duration(primary_level,PL_ENTER),           //EN Primary school non-completer
//    duration(primary_level,PL_GRAD)             //EN Primary school graduate
//}
//};


//table Person RTAB_DeathsByRegion       //EN (04) Deaths by main region
//[in_rtab_years]
//{
//    {
//        transitions(alive, TRUE, FALSE)      //EN Deaths	
//    }
//    *rtab_years
//    * rtab_reg +
//};


//table Person RTAB_BirthsByRegion       //EN (05) Births by main region
//[in_rtab_years && person_type == PT_CHILD]
//{
//    {
//        entrances(set_alive, TRUE)      //EN Births	
//    }
//    *rtab_years
//    * rtab_reg +
//};

//table Person RTAB_BirthsByEducMother       //EN (06) Births by education of mother
//[in_rtab_years && person_type == PT_CHILD]
//{
//    {
//        entrances(set_alive, TRUE) 					    //EN Births
//    }
//    *rtab_years
//    * educ_mother +
//};

//table Person RTAB_BirthsByAgeMother       //EN (07) Births by age of mother
//[in_rtab_years && count_parity]
//{
//    {
//        parity 		                                    //EN Births
//    }
//    *rtab_years                                              //EN Calendar Year        
//    *split(integer_age,AGE_15_16_18) +                        //EN Age group
//};

//table Person RTAB_UnionFormationByAge       //EN (08) Firtst union formations by age group (females)
//[in_rtab_years && count_parity]
//{
//    {
//        transitions(in_union, FALSE, TRUE) //EN Unions
//    }
//    *rtab_years                                              //EN Calendar Year        
//    *split(integer_age,AGE_15_16_18) +                       //EN Age group
//};



//table Person RTAB_AgeAtFirstUnionFormation //EN (09) Age at first union formation
//[sex == FEMALE && in_rtab_years && count_parity]
//{
//    {
//        //EN Average age at first union formation decimals=2
//        value_at_transitions(in_union, FALSE, TRUE,age) / transitions(in_union, FALSE, TRUE)
//    }
//    *rtab_years
//    *rtab_column
//};

//table Person RTAB_TabDeathsByAgeGroup                      //EN (10) Infant deaths (age 0-4)
//[in_rtab_years && integer_age < 5]
//{
//    {
//        transitions(alive, TRUE, FALSE)                    //EN Deaths	
//    }
//    *rtab_years                                              //EN Calendar Year        
//    * split(integer_age, AGE_RTAB_MORT) +                    //EN Age group
//};

//table Person RTAB_EducationActivePop //EN (11) Education composition of population 16-59
//[ integer_age > 15 && integer_age < 60 && in_rtab_years]
//{
//    rtab_reg + *
//    rtab_years *
//{
//        duration(primary_level,PL_NO) / duration(),              //EN Never entered primary school (%) decimals=4
//        duration(primary_level,PL_ENTER) / duration(),           //EN Primary school non-completer (%) decimals=4
//        duration(primary_level,PL_GRAD) / duration()             //EN Primary school graduate (%) decimals=4
//    }
//};


//table Person RTAB_PrimSchoolEntries                     //EN (12) Primary school entries by Willaya
//[in_rtab_years]
//{
//    {
//        transitions(primary_level,PL_NO,PL_ENTER)    //EN School entries
//    }
//    *rtab_years
//    * province_nat +
//};


//table Person RTAB_PrimSchoolGraduations                     //EN (13) Primary school graduations by Willaya
//[in_rtab_years]
//{
//    {
//        transitions(primary_level,PL_ENTER,PL_GRAD)         //EN School graduations
//    }
//    *rtab_years
//    * province_nat +
//};



} // namespace 
